// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2018.3
// Copyright (C) 1986-2018 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="RGB2yfb,hls_ip_2018_3,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z010clg400-1,HLS_INPUT_CLOCK=7.500000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=6.562000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=4,HLS_SYN_DSP=18,HLS_SYN_FF=3638,HLS_SYN_LUT=3481,HLS_VERSION=2018_3}" *)

module RGB2yfb (
        ap_clk,
        ap_rst_n,
        m_axi_gmem_AWVALID,
        m_axi_gmem_AWREADY,
        m_axi_gmem_AWADDR,
        m_axi_gmem_AWID,
        m_axi_gmem_AWLEN,
        m_axi_gmem_AWSIZE,
        m_axi_gmem_AWBURST,
        m_axi_gmem_AWLOCK,
        m_axi_gmem_AWCACHE,
        m_axi_gmem_AWPROT,
        m_axi_gmem_AWQOS,
        m_axi_gmem_AWREGION,
        m_axi_gmem_AWUSER,
        m_axi_gmem_WVALID,
        m_axi_gmem_WREADY,
        m_axi_gmem_WDATA,
        m_axi_gmem_WSTRB,
        m_axi_gmem_WLAST,
        m_axi_gmem_WID,
        m_axi_gmem_WUSER,
        m_axi_gmem_ARVALID,
        m_axi_gmem_ARREADY,
        m_axi_gmem_ARADDR,
        m_axi_gmem_ARID,
        m_axi_gmem_ARLEN,
        m_axi_gmem_ARSIZE,
        m_axi_gmem_ARBURST,
        m_axi_gmem_ARLOCK,
        m_axi_gmem_ARCACHE,
        m_axi_gmem_ARPROT,
        m_axi_gmem_ARQOS,
        m_axi_gmem_ARREGION,
        m_axi_gmem_ARUSER,
        m_axi_gmem_RVALID,
        m_axi_gmem_RREADY,
        m_axi_gmem_RDATA,
        m_axi_gmem_RLAST,
        m_axi_gmem_RID,
        m_axi_gmem_RUSER,
        m_axi_gmem_RRESP,
        m_axi_gmem_BVALID,
        m_axi_gmem_BREADY,
        m_axi_gmem_BRESP,
        m_axi_gmem_BID,
        m_axi_gmem_BUSER,
        video_in_TDATA,
        video_in_TVALID,
        video_in_TREADY,
        video_in_TKEEP,
        video_in_TSTRB,
        video_in_TUSER,
        video_in_TLAST,
        video_in_TID,
        video_in_TDEST,
        s_axi_AXILiteS_AWVALID,
        s_axi_AXILiteS_AWREADY,
        s_axi_AXILiteS_AWADDR,
        s_axi_AXILiteS_WVALID,
        s_axi_AXILiteS_WREADY,
        s_axi_AXILiteS_WDATA,
        s_axi_AXILiteS_WSTRB,
        s_axi_AXILiteS_ARVALID,
        s_axi_AXILiteS_ARREADY,
        s_axi_AXILiteS_ARADDR,
        s_axi_AXILiteS_RVALID,
        s_axi_AXILiteS_RREADY,
        s_axi_AXILiteS_RDATA,
        s_axi_AXILiteS_RRESP,
        s_axi_AXILiteS_BVALID,
        s_axi_AXILiteS_BREADY,
        s_axi_AXILiteS_BRESP,
        interrupt
);

parameter    ap_ST_fsm_state1 = 16'd1;
parameter    ap_ST_fsm_state2 = 16'd2;
parameter    ap_ST_fsm_state3 = 16'd4;
parameter    ap_ST_fsm_state4 = 16'd8;
parameter    ap_ST_fsm_state5 = 16'd16;
parameter    ap_ST_fsm_state6 = 16'd32;
parameter    ap_ST_fsm_state7 = 16'd64;
parameter    ap_ST_fsm_pp0_stage0 = 16'd128;
parameter    ap_ST_fsm_pp0_stage1 = 16'd256;
parameter    ap_ST_fsm_pp0_stage2 = 16'd512;
parameter    ap_ST_fsm_pp0_stage3 = 16'd1024;
parameter    ap_ST_fsm_pp0_stage4 = 16'd2048;
parameter    ap_ST_fsm_pp0_stage5 = 16'd4096;
parameter    ap_ST_fsm_pp0_stage6 = 16'd8192;
parameter    ap_ST_fsm_pp0_stage7 = 16'd16384;
parameter    ap_ST_fsm_state36 = 16'd32768;
parameter    C_S_AXI_AXILITES_DATA_WIDTH = 32;
parameter    C_S_AXI_AXILITES_ADDR_WIDTH = 6;
parameter    C_S_AXI_DATA_WIDTH = 32;
parameter    C_M_AXI_GMEM_ID_WIDTH = 1;
parameter    C_M_AXI_GMEM_ADDR_WIDTH = 32;
parameter    C_M_AXI_GMEM_DATA_WIDTH = 64;
parameter    C_M_AXI_GMEM_AWUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_ARUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_WUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_RUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_BUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_USER_VALUE = 0;
parameter    C_M_AXI_GMEM_PROT_VALUE = 0;
parameter    C_M_AXI_GMEM_CACHE_VALUE = 3;
parameter    C_M_AXI_DATA_WIDTH = 32;

parameter C_S_AXI_AXILITES_WSTRB_WIDTH = (32 / 8);
parameter C_S_AXI_WSTRB_WIDTH = (32 / 8);
parameter C_M_AXI_GMEM_WSTRB_WIDTH = (64 / 8);
parameter C_M_AXI_WSTRB_WIDTH = (32 / 8);

input   ap_clk;
input   ap_rst_n;
output   m_axi_gmem_AWVALID;
input   m_axi_gmem_AWREADY;
output  [C_M_AXI_GMEM_ADDR_WIDTH - 1:0] m_axi_gmem_AWADDR;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_AWID;
output  [7:0] m_axi_gmem_AWLEN;
output  [2:0] m_axi_gmem_AWSIZE;
output  [1:0] m_axi_gmem_AWBURST;
output  [1:0] m_axi_gmem_AWLOCK;
output  [3:0] m_axi_gmem_AWCACHE;
output  [2:0] m_axi_gmem_AWPROT;
output  [3:0] m_axi_gmem_AWQOS;
output  [3:0] m_axi_gmem_AWREGION;
output  [C_M_AXI_GMEM_AWUSER_WIDTH - 1:0] m_axi_gmem_AWUSER;
output   m_axi_gmem_WVALID;
input   m_axi_gmem_WREADY;
output  [C_M_AXI_GMEM_DATA_WIDTH - 1:0] m_axi_gmem_WDATA;
output  [C_M_AXI_GMEM_WSTRB_WIDTH - 1:0] m_axi_gmem_WSTRB;
output   m_axi_gmem_WLAST;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_WID;
output  [C_M_AXI_GMEM_WUSER_WIDTH - 1:0] m_axi_gmem_WUSER;
output   m_axi_gmem_ARVALID;
input   m_axi_gmem_ARREADY;
output  [C_M_AXI_GMEM_ADDR_WIDTH - 1:0] m_axi_gmem_ARADDR;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_ARID;
output  [7:0] m_axi_gmem_ARLEN;
output  [2:0] m_axi_gmem_ARSIZE;
output  [1:0] m_axi_gmem_ARBURST;
output  [1:0] m_axi_gmem_ARLOCK;
output  [3:0] m_axi_gmem_ARCACHE;
output  [2:0] m_axi_gmem_ARPROT;
output  [3:0] m_axi_gmem_ARQOS;
output  [3:0] m_axi_gmem_ARREGION;
output  [C_M_AXI_GMEM_ARUSER_WIDTH - 1:0] m_axi_gmem_ARUSER;
input   m_axi_gmem_RVALID;
output   m_axi_gmem_RREADY;
input  [C_M_AXI_GMEM_DATA_WIDTH - 1:0] m_axi_gmem_RDATA;
input   m_axi_gmem_RLAST;
input  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_RID;
input  [C_M_AXI_GMEM_RUSER_WIDTH - 1:0] m_axi_gmem_RUSER;
input  [1:0] m_axi_gmem_RRESP;
input   m_axi_gmem_BVALID;
output   m_axi_gmem_BREADY;
input  [1:0] m_axi_gmem_BRESP;
input  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_BID;
input  [C_M_AXI_GMEM_BUSER_WIDTH - 1:0] m_axi_gmem_BUSER;
input  [23:0] video_in_TDATA;
input   video_in_TVALID;
output   video_in_TREADY;
input  [2:0] video_in_TKEEP;
input  [2:0] video_in_TSTRB;
input  [0:0] video_in_TUSER;
input  [0:0] video_in_TLAST;
input  [0:0] video_in_TID;
input  [0:0] video_in_TDEST;
input   s_axi_AXILiteS_AWVALID;
output   s_axi_AXILiteS_AWREADY;
input  [C_S_AXI_AXILITES_ADDR_WIDTH - 1:0] s_axi_AXILiteS_AWADDR;
input   s_axi_AXILiteS_WVALID;
output   s_axi_AXILiteS_WREADY;
input  [C_S_AXI_AXILITES_DATA_WIDTH - 1:0] s_axi_AXILiteS_WDATA;
input  [C_S_AXI_AXILITES_WSTRB_WIDTH - 1:0] s_axi_AXILiteS_WSTRB;
input   s_axi_AXILiteS_ARVALID;
output   s_axi_AXILiteS_ARREADY;
input  [C_S_AXI_AXILITES_ADDR_WIDTH - 1:0] s_axi_AXILiteS_ARADDR;
output   s_axi_AXILiteS_RVALID;
input   s_axi_AXILiteS_RREADY;
output  [C_S_AXI_AXILITES_DATA_WIDTH - 1:0] s_axi_AXILiteS_RDATA;
output  [1:0] s_axi_AXILiteS_RRESP;
output   s_axi_AXILiteS_BVALID;
input   s_axi_AXILiteS_BREADY;
output  [1:0] s_axi_AXILiteS_BRESP;
output   interrupt;

reg video_in_TREADY;

 reg    ap_rst_n_inv;
wire    ap_start;
reg    ap_done;
reg    ap_idle;
(* fsm_encoding = "none" *) reg   [15:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg    ap_ready;
wire   [31:0] fb_out;
wire   [31:0] hsize;
wire   [31:0] vsize;
wire   [31:0] stride;
wire   [31:0] fsize;
reg    gmem_blk_n_AW;
wire    ap_CS_fsm_pp0_stage5;
reg    ap_enable_reg_pp0_iter2;
wire    ap_block_pp0_stage5;
reg   [0:0] tmp_25_reg_1119;
reg    gmem_blk_n_W;
wire    ap_CS_fsm_pp0_stage6;
wire    ap_block_pp0_stage6;
reg   [0:0] exitcond_flatten_reg_923;
reg   [0:0] exitcond_flatten_reg_923_pp0_iter2_reg;
reg    gmem_blk_n_B;
wire    ap_CS_fsm_pp0_stage3;
reg    ap_enable_reg_pp0_iter3;
wire    ap_block_pp0_stage3;
reg   [0:0] tmp_27_reg_1134;
reg    video_in_TDATA_blk_n;
wire    ap_CS_fsm_state7;
wire   [0:0] tmp_1_nbreadreq_fu_160_p9;
wire    ap_CS_fsm_pp0_stage1;
reg    ap_enable_reg_pp0_iter0;
wire    ap_block_pp0_stage1;
wire    ap_CS_fsm_pp0_stage2;
wire    ap_block_pp0_stage2;
wire    ap_CS_fsm_pp0_stage4;
wire    ap_block_pp0_stage4;
wire    ap_CS_fsm_pp0_stage7;
wire    ap_block_pp0_stage7;
wire    ap_CS_fsm_pp0_stage0;
wire    ap_block_pp0_stage0;
wire   [0:0] exitcond_flatten_fu_383_p2;
reg   [0:0] ap_phi_mux_is_first_line_1_phi_fu_273_p4;
reg    gmem_AWVALID;
wire    gmem_AWREADY;
wire   [31:0] gmem_AWADDR;
reg    gmem_WVALID;
wire    gmem_WREADY;
wire    gmem_ARREADY;
wire    gmem_RVALID;
wire   [63:0] gmem_RDATA;
wire    gmem_RLAST;
wire   [0:0] gmem_RID;
wire   [0:0] gmem_RUSER;
wire   [1:0] gmem_RRESP;
wire    gmem_BVALID;
reg    gmem_BREADY;
wire   [1:0] gmem_BRESP;
wire   [0:0] gmem_BID;
wire   [0:0] gmem_BUSER;
reg   [16:0] indvar_flatten_reg_237;
reg    ap_predicate_op99_read_state8;
reg    ap_block_state8_pp0_stage0_iter0;
wire    ap_block_state16_pp0_stage0_iter1;
wire    ap_block_state24_pp0_stage0_iter2;
wire    ap_block_state32_pp0_stage0_iter3;
reg    ap_block_pp0_stage0_11001;
reg   [38:0] p_1_rec_reg_249;
reg   [23:0] pix_0_1_reg_260;
reg   [0:0] is_first_line_1_reg_269;
reg   [7:0] blk_idx_reg_282;
reg   [7:0] reg_328;
reg    ap_block_state9_pp0_stage1_iter0;
wire    ap_block_state17_pp0_stage1_iter1;
wire    ap_block_state25_pp0_stage1_iter2;
wire    ap_block_state33_pp0_stage1_iter3;
reg    ap_block_pp0_stage1_11001;
reg    ap_block_state10_pp0_stage2_iter0;
wire    ap_block_state18_pp0_stage2_iter1;
wire    ap_block_state26_pp0_stage2_iter2;
wire    ap_block_state34_pp0_stage2_iter3;
reg    ap_block_pp0_stage2_11001;
reg    ap_block_state11_pp0_stage3_iter0;
wire    ap_block_state19_pp0_stage3_iter1;
wire    ap_block_state27_pp0_stage3_iter2;
reg    ap_block_state35_pp0_stage3_iter3;
reg    ap_block_pp0_stage3_11001;
reg    ap_block_state12_pp0_stage4_iter0;
wire    ap_block_state20_pp0_stage4_iter1;
wire    ap_block_state28_pp0_stage4_iter2;
reg    ap_block_pp0_stage4_11001;
reg    ap_block_state13_pp0_stage5_iter0;
wire    ap_block_state21_pp0_stage5_iter1;
wire    ap_block_state29_pp0_stage5_iter2;
reg    ap_sig_ioackin_gmem_AWREADY;
reg    ap_block_state29_io;
reg    ap_block_pp0_stage5_11001;
reg    ap_block_state14_pp0_stage6_iter0;
wire    ap_block_state22_pp0_stage6_iter1;
wire    ap_block_state30_pp0_stage6_iter2;
reg    ap_sig_ioackin_gmem_WREADY;
reg    ap_block_state30_io;
reg    ap_block_pp0_stage6_11001;
reg    ap_block_state15_pp0_stage7_iter0;
wire    ap_block_state23_pp0_stage7_iter1;
wire    ap_block_state31_pp0_stage7_iter2;
reg    ap_block_pp0_stage7_11001;
reg   [28:0] tmp_3_reg_871;
reg   [28:0] tmp_reg_876;
wire    ap_CS_fsm_state2;
wire   [39:0] tmp_3_cast_fu_361_p1;
reg   [39:0] tmp_3_cast_reg_887;
wire    ap_CS_fsm_state4;
wire   [38:0] tmp_1_cast1_fu_364_p1;
reg   [38:0] tmp_1_cast1_reg_892;
wire   [39:0] grp_fu_355_p2;
reg   [39:0] tmp_2_reg_897;
wire   [1:0] i_1_fu_373_p2;
reg   [1:0] i_1_reg_905;
wire    ap_CS_fsm_state5;
reg    ap_block_state7;
wire   [0:0] tmp_user_V_fu_379_p1;
reg   [0:0] exitcond_flatten_reg_923_pp0_iter1_reg;
wire   [16:0] indvar_flatten_next_fu_389_p2;
reg   [16:0] indvar_flatten_next_reg_927;
wire   [38:0] tmp_15_mid2_v_v_v_fu_406_p3;
reg   [38:0] tmp_15_mid2_v_v_v_reg_933;
wire   [7:0] tmp_16_fu_414_p1;
reg   [7:0] tmp_16_reg_939;
reg   [7:0] tmp_4_reg_944;
wire   [15:0] tmp_8_fu_442_p2;
reg   [15:0] tmp_8_reg_949;
wire   [7:0] blk_idx_1_fu_460_p3;
reg   [7:0] blk_idx_1_reg_954;
wire   [15:0] grp_fu_751_p3;
reg   [15:0] tmp1_reg_959;
wire   [7:0] tmp_17_fu_471_p1;
reg   [7:0] tmp_17_reg_964;
wire   [15:0] tmp_8_1_fu_479_p2;
reg   [15:0] tmp_8_1_reg_969;
reg   [7:0] y1_reg_974;
reg   [7:0] y1_reg_974_pp0_iter1_reg;
reg   [7:0] y1_reg_974_pp0_iter2_reg;
wire   [15:0] grp_fu_766_p3;
reg   [15:0] tmp2_reg_979;
wire   [7:0] tmp_18_fu_506_p1;
reg   [7:0] tmp_18_reg_984;
wire   [15:0] tmp_8_2_fu_514_p2;
reg   [15:0] tmp_8_2_reg_989;
reg   [7:0] y1_1_reg_994;
reg   [7:0] y1_1_reg_994_pp0_iter1_reg;
reg   [7:0] y1_1_reg_994_pp0_iter2_reg;
wire   [15:0] grp_fu_781_p3;
reg   [15:0] tmp3_reg_999;
wire   [7:0] tmp_19_fu_536_p1;
reg   [7:0] tmp_19_reg_1004;
wire   [15:0] tmp_8_3_fu_544_p2;
reg   [15:0] tmp_8_3_reg_1009;
reg   [7:0] y1_2_reg_1014;
reg   [7:0] y1_2_reg_1014_pp0_iter1_reg;
reg   [7:0] y1_2_reg_1014_pp0_iter2_reg;
wire   [15:0] grp_fu_796_p3;
reg   [15:0] tmp4_reg_1019;
wire   [7:0] tmp_20_fu_566_p1;
reg   [7:0] tmp_20_reg_1024;
wire   [15:0] tmp_8_4_fu_574_p2;
reg   [15:0] tmp_8_4_reg_1029;
reg   [7:0] y1_3_reg_1034;
reg   [7:0] y1_3_reg_1034_pp0_iter1_reg;
wire   [15:0] grp_fu_811_p3;
reg   [15:0] tmp5_reg_1039;
wire   [7:0] tmp_21_fu_596_p1;
reg   [7:0] tmp_21_reg_1044;
wire   [15:0] tmp_8_5_fu_604_p2;
reg   [15:0] tmp_8_5_reg_1049;
reg   [7:0] y1_4_reg_1054;
reg   [7:0] y1_4_reg_1054_pp0_iter1_reg;
wire   [15:0] grp_fu_826_p3;
reg   [15:0] tmp6_reg_1059;
wire   [7:0] tmp_22_fu_626_p1;
reg   [7:0] tmp_22_reg_1064;
wire   [15:0] tmp_8_6_fu_634_p2;
reg   [15:0] tmp_8_6_reg_1069;
reg   [7:0] y1_5_reg_1074;
reg   [7:0] y1_5_reg_1074_pp0_iter1_reg;
wire   [15:0] grp_fu_841_p3;
reg   [15:0] tmp7_reg_1079;
reg   [23:0] tmp_data_V_7_reg_1084;
wire   [7:0] tmp_23_fu_656_p1;
reg   [7:0] tmp_23_reg_1089;
wire   [15:0] tmp_8_7_fu_664_p2;
reg   [15:0] tmp_8_7_reg_1094;
reg   [7:0] y1_6_reg_1099;
reg   [7:0] y1_6_reg_1099_pp0_iter2_reg;
wire   [15:0] grp_fu_856_p3;
reg   [15:0] tmp8_reg_1104;
reg    ap_enable_reg_pp0_iter1;
wire   [39:0] fb_out2_sum3_fu_695_p2;
reg   [39:0] fb_out2_sum3_reg_1109;
reg   [39:0] fb_out2_sum3_reg_1109_pp0_iter2_reg;
reg   [7:0] y1_7_reg_1114;
reg   [7:0] y1_7_reg_1114_pp0_iter2_reg;
wire   [0:0] tmp_25_fu_712_p2;
wire   [63:0] blk_7_fu_718_p9;
reg   [63:0] blk_7_reg_1123;
wire   [0:0] tmp_27_fu_740_p2;
wire   [39:0] p_1_rec1_fu_746_p2;
wire    ap_CS_fsm_state36;
reg    ap_block_pp0_stage0_subdone;
reg    ap_condition_pp0_exit_iter0_state8;
reg    ap_block_pp0_stage7_subdone;
reg    ap_block_pp0_stage3_subdone;
reg   [39:0] p_09_rec_reg_214;
reg   [1:0] i_reg_226;
reg   [16:0] ap_phi_mux_indvar_flatten_phi_fu_241_p4;
reg   [38:0] ap_phi_mux_p_1_rec_phi_fu_253_p4;
reg   [23:0] ap_phi_mux_pix_0_1_phi_fu_263_p4;
reg   [7:0] ap_phi_mux_blk_idx_phi_fu_286_p4;
reg   [23:0] ap_phi_mux_pix_0_3_phi_fu_296_p4;
wire   [23:0] ap_phi_reg_pp0_iter0_pix_0_3_reg_293;
wire   [63:0] fb_out2_sum3_cast_fu_730_p1;
reg    ap_reg_ioackin_gmem_AWREADY;
reg    ap_block_pp0_stage5_01001;
reg    ap_reg_ioackin_gmem_WREADY;
reg    ap_block_pp0_stage6_01001;
wire   [28:0] grp_fu_355_p0;
wire   [10:0] grp_fu_355_p1;
wire   [0:0] tmp_7_fu_395_p2;
wire   [38:0] p_rec_dup4_fu_401_p2;
wire   [7:0] tmp_9_cast_fu_418_p4;
wire   [7:0] tmp_8_fu_442_p1;
wire   [8:0] grp_fu_448_p1;
wire   [7:0] blk_idx_op_fu_454_p2;
wire   [7:0] grp_fu_308_p4;
wire   [7:0] tmp_8_1_fu_479_p1;
wire   [8:0] grp_fu_485_p1;
wire   [15:0] grp_fu_758_p3;
wire   [7:0] tmp_8_2_fu_514_p1;
wire   [15:0] grp_fu_773_p3;
wire   [7:0] tmp_8_3_fu_544_p1;
wire   [15:0] grp_fu_788_p3;
wire   [7:0] tmp_8_4_fu_574_p1;
wire   [15:0] grp_fu_803_p3;
wire   [7:0] tmp_8_5_fu_604_p1;
wire   [15:0] grp_fu_818_p3;
wire   [7:0] tmp_8_6_fu_634_p1;
wire   [15:0] grp_fu_833_p3;
wire   [7:0] tmp_8_7_fu_664_p1;
wire   [39:0] tmp_15_mid2_v_v_fu_670_p1;
wire   [15:0] grp_fu_848_p3;
wire   [39:0] tmp_15_mid2_v_fu_673_p2;
wire   [15:0] grp_fu_863_p3;
wire   [16:0] grp_fu_448_p2;
wire   [16:0] grp_fu_485_p2;
wire   [7:0] grp_fu_751_p0;
wire   [7:0] grp_fu_751_p1;
wire   [5:0] grp_fu_758_p0;
wire   [7:0] grp_fu_758_p1;
wire   [7:0] grp_fu_766_p0;
wire   [7:0] grp_fu_766_p1;
wire   [5:0] grp_fu_773_p0;
wire   [7:0] grp_fu_773_p1;
wire   [7:0] grp_fu_781_p0;
wire   [7:0] grp_fu_781_p1;
wire   [5:0] grp_fu_788_p0;
wire   [7:0] grp_fu_788_p1;
wire   [7:0] grp_fu_796_p0;
wire   [7:0] grp_fu_796_p1;
wire   [5:0] grp_fu_803_p0;
wire   [7:0] grp_fu_803_p1;
wire   [7:0] grp_fu_811_p0;
wire   [7:0] grp_fu_811_p1;
wire   [5:0] grp_fu_818_p0;
wire   [7:0] grp_fu_818_p1;
wire   [7:0] grp_fu_826_p0;
wire   [7:0] grp_fu_826_p1;
wire   [5:0] grp_fu_833_p0;
wire   [7:0] grp_fu_833_p1;
wire   [7:0] grp_fu_841_p0;
wire   [7:0] grp_fu_841_p1;
wire   [5:0] grp_fu_848_p0;
wire   [7:0] grp_fu_848_p1;
wire   [7:0] grp_fu_856_p0;
wire   [7:0] grp_fu_856_p1;
wire   [5:0] grp_fu_863_p0;
wire   [7:0] grp_fu_863_p1;
wire   [0:0] exitcond_fu_367_p2;
reg    grp_fu_448_ce;
reg    grp_fu_485_ce;
reg   [15:0] ap_NS_fsm;
reg    ap_block_pp0_stage1_subdone;
reg    ap_block_pp0_stage2_subdone;
reg    ap_block_pp0_stage4_subdone;
reg    ap_block_pp0_stage5_subdone;
reg    ap_block_pp0_stage6_subdone;
reg    ap_idle_pp0;
wire    ap_enable_pp0;
wire   [39:0] grp_fu_355_p00;
wire   [15:0] grp_fu_751_p10;
wire   [13:0] grp_fu_758_p10;
wire   [15:0] grp_fu_766_p10;
wire   [13:0] grp_fu_773_p10;
wire   [15:0] grp_fu_781_p10;
wire   [13:0] grp_fu_788_p10;
wire   [15:0] grp_fu_796_p10;
wire   [13:0] grp_fu_803_p10;
wire   [15:0] grp_fu_811_p10;
wire   [13:0] grp_fu_818_p10;
wire   [15:0] grp_fu_826_p10;
wire   [13:0] grp_fu_833_p10;
wire   [15:0] grp_fu_841_p10;
wire   [13:0] grp_fu_848_p10;
wire   [15:0] grp_fu_856_p10;
wire   [13:0] grp_fu_863_p10;
wire   [15:0] tmp_8_1_fu_479_p10;
wire   [15:0] tmp_8_2_fu_514_p10;
wire   [15:0] tmp_8_3_fu_544_p10;
wire   [15:0] tmp_8_4_fu_574_p10;
wire   [15:0] tmp_8_5_fu_604_p10;
wire   [15:0] tmp_8_6_fu_634_p10;
wire   [15:0] tmp_8_7_fu_664_p10;
wire   [15:0] tmp_8_fu_442_p10;
reg    ap_condition_1290;
reg    ap_condition_1293;
reg    ap_condition_1297;
wire   [31:0] ap_return;

// power-on initialization
initial begin
#0 ap_CS_fsm = 16'd1;
#0 ap_enable_reg_pp0_iter2 = 1'b0;
#0 ap_enable_reg_pp0_iter3 = 1'b0;
#0 ap_enable_reg_pp0_iter0 = 1'b0;
#0 ap_enable_reg_pp0_iter1 = 1'b0;
#0 ap_reg_ioackin_gmem_AWREADY = 1'b0;
#0 ap_reg_ioackin_gmem_WREADY = 1'b0;
end

RGB2yfb_AXILiteS_s_axi #(
    .C_S_AXI_ADDR_WIDTH( C_S_AXI_AXILITES_ADDR_WIDTH ),
    .C_S_AXI_DATA_WIDTH( C_S_AXI_AXILITES_DATA_WIDTH ))
RGB2yfb_AXILiteS_s_axi_U(
    .AWVALID(s_axi_AXILiteS_AWVALID),
    .AWREADY(s_axi_AXILiteS_AWREADY),
    .AWADDR(s_axi_AXILiteS_AWADDR),
    .WVALID(s_axi_AXILiteS_WVALID),
    .WREADY(s_axi_AXILiteS_WREADY),
    .WDATA(s_axi_AXILiteS_WDATA),
    .WSTRB(s_axi_AXILiteS_WSTRB),
    .ARVALID(s_axi_AXILiteS_ARVALID),
    .ARREADY(s_axi_AXILiteS_ARREADY),
    .ARADDR(s_axi_AXILiteS_ARADDR),
    .RVALID(s_axi_AXILiteS_RVALID),
    .RREADY(s_axi_AXILiteS_RREADY),
    .RDATA(s_axi_AXILiteS_RDATA),
    .RRESP(s_axi_AXILiteS_RRESP),
    .BVALID(s_axi_AXILiteS_BVALID),
    .BREADY(s_axi_AXILiteS_BREADY),
    .BRESP(s_axi_AXILiteS_BRESP),
    .ACLK(ap_clk),
    .ARESET(ap_rst_n_inv),
    .ACLK_EN(1'b1),
    .ap_start(ap_start),
    .interrupt(interrupt),
    .ap_ready(ap_ready),
    .ap_done(ap_done),
    .ap_idle(ap_idle),
    .ap_return(32'd0),
    .fb_out(fb_out),
    .hsize(hsize),
    .vsize(vsize),
    .stride(stride),
    .fsize(fsize)
);

RGB2yfb_gmem_m_axi #(
    .CONSERVATIVE( 0 ),
    .USER_DW( 64 ),
    .USER_AW( 32 ),
    .USER_MAXREQS( 5 ),
    .NUM_READ_OUTSTANDING( 16 ),
    .NUM_WRITE_OUTSTANDING( 16 ),
    .MAX_READ_BURST_LENGTH( 16 ),
    .MAX_WRITE_BURST_LENGTH( 16 ),
    .C_M_AXI_ID_WIDTH( C_M_AXI_GMEM_ID_WIDTH ),
    .C_M_AXI_ADDR_WIDTH( C_M_AXI_GMEM_ADDR_WIDTH ),
    .C_M_AXI_DATA_WIDTH( C_M_AXI_GMEM_DATA_WIDTH ),
    .C_M_AXI_AWUSER_WIDTH( C_M_AXI_GMEM_AWUSER_WIDTH ),
    .C_M_AXI_ARUSER_WIDTH( C_M_AXI_GMEM_ARUSER_WIDTH ),
    .C_M_AXI_WUSER_WIDTH( C_M_AXI_GMEM_WUSER_WIDTH ),
    .C_M_AXI_RUSER_WIDTH( C_M_AXI_GMEM_RUSER_WIDTH ),
    .C_M_AXI_BUSER_WIDTH( C_M_AXI_GMEM_BUSER_WIDTH ),
    .C_USER_VALUE( C_M_AXI_GMEM_USER_VALUE ),
    .C_PROT_VALUE( C_M_AXI_GMEM_PROT_VALUE ),
    .C_CACHE_VALUE( C_M_AXI_GMEM_CACHE_VALUE ))
RGB2yfb_gmem_m_axi_U(
    .AWVALID(m_axi_gmem_AWVALID),
    .AWREADY(m_axi_gmem_AWREADY),
    .AWADDR(m_axi_gmem_AWADDR),
    .AWID(m_axi_gmem_AWID),
    .AWLEN(m_axi_gmem_AWLEN),
    .AWSIZE(m_axi_gmem_AWSIZE),
    .AWBURST(m_axi_gmem_AWBURST),
    .AWLOCK(m_axi_gmem_AWLOCK),
    .AWCACHE(m_axi_gmem_AWCACHE),
    .AWPROT(m_axi_gmem_AWPROT),
    .AWQOS(m_axi_gmem_AWQOS),
    .AWREGION(m_axi_gmem_AWREGION),
    .AWUSER(m_axi_gmem_AWUSER),
    .WVALID(m_axi_gmem_WVALID),
    .WREADY(m_axi_gmem_WREADY),
    .WDATA(m_axi_gmem_WDATA),
    .WSTRB(m_axi_gmem_WSTRB),
    .WLAST(m_axi_gmem_WLAST),
    .WID(m_axi_gmem_WID),
    .WUSER(m_axi_gmem_WUSER),
    .ARVALID(m_axi_gmem_ARVALID),
    .ARREADY(m_axi_gmem_ARREADY),
    .ARADDR(m_axi_gmem_ARADDR),
    .ARID(m_axi_gmem_ARID),
    .ARLEN(m_axi_gmem_ARLEN),
    .ARSIZE(m_axi_gmem_ARSIZE),
    .ARBURST(m_axi_gmem_ARBURST),
    .ARLOCK(m_axi_gmem_ARLOCK),
    .ARCACHE(m_axi_gmem_ARCACHE),
    .ARPROT(m_axi_gmem_ARPROT),
    .ARQOS(m_axi_gmem_ARQOS),
    .ARREGION(m_axi_gmem_ARREGION),
    .ARUSER(m_axi_gmem_ARUSER),
    .RVALID(m_axi_gmem_RVALID),
    .RREADY(m_axi_gmem_RREADY),
    .RDATA(m_axi_gmem_RDATA),
    .RLAST(m_axi_gmem_RLAST),
    .RID(m_axi_gmem_RID),
    .RUSER(m_axi_gmem_RUSER),
    .RRESP(m_axi_gmem_RRESP),
    .BVALID(m_axi_gmem_BVALID),
    .BREADY(m_axi_gmem_BREADY),
    .BRESP(m_axi_gmem_BRESP),
    .BID(m_axi_gmem_BID),
    .BUSER(m_axi_gmem_BUSER),
    .ACLK(ap_clk),
    .ARESET(ap_rst_n_inv),
    .ACLK_EN(1'b1),
    .I_ARVALID(1'b0),
    .I_ARREADY(gmem_ARREADY),
    .I_ARADDR(32'd0),
    .I_ARID(1'd0),
    .I_ARLEN(32'd0),
    .I_ARSIZE(3'd0),
    .I_ARLOCK(2'd0),
    .I_ARCACHE(4'd0),
    .I_ARQOS(4'd0),
    .I_ARPROT(3'd0),
    .I_ARUSER(1'd0),
    .I_ARBURST(2'd0),
    .I_ARREGION(4'd0),
    .I_RVALID(gmem_RVALID),
    .I_RREADY(1'b0),
    .I_RDATA(gmem_RDATA),
    .I_RID(gmem_RID),
    .I_RUSER(gmem_RUSER),
    .I_RRESP(gmem_RRESP),
    .I_RLAST(gmem_RLAST),
    .I_AWVALID(gmem_AWVALID),
    .I_AWREADY(gmem_AWREADY),
    .I_AWADDR(gmem_AWADDR),
    .I_AWID(1'd0),
    .I_AWLEN(32'd160),
    .I_AWSIZE(3'd0),
    .I_AWLOCK(2'd0),
    .I_AWCACHE(4'd0),
    .I_AWQOS(4'd0),
    .I_AWPROT(3'd0),
    .I_AWUSER(1'd0),
    .I_AWBURST(2'd0),
    .I_AWREGION(4'd0),
    .I_WVALID(gmem_WVALID),
    .I_WREADY(gmem_WREADY),
    .I_WDATA(blk_7_reg_1123),
    .I_WID(1'd0),
    .I_WUSER(1'd0),
    .I_WLAST(1'b0),
    .I_WSTRB(8'd255),
    .I_BVALID(gmem_BVALID),
    .I_BREADY(gmem_BREADY),
    .I_BRESP(gmem_BRESP),
    .I_BID(gmem_BID),
    .I_BUSER(gmem_BUSER)
);

RGB2yfb_mul_29ns_11ns_40_3_1 #(
    .ID( 1 ),
    .NUM_STAGE( 3 ),
    .din0_WIDTH( 29 ),
    .din1_WIDTH( 11 ),
    .dout_WIDTH( 40 ))
RGB2yfb_mul_29ns_11ns_40_3_1_U1(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .din0(grp_fu_355_p0),
    .din1(grp_fu_355_p1),
    .ce(1'b1),
    .dout(grp_fu_355_p2)
);

RGB2yfb_urem_17ns_9ns_17_21_1 #(
    .ID( 1 ),
    .NUM_STAGE( 21 ),
    .din0_WIDTH( 17 ),
    .din1_WIDTH( 9 ),
    .dout_WIDTH( 17 ))
RGB2yfb_urem_17ns_9ns_17_21_1_U2(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .din0(ap_phi_mux_indvar_flatten_phi_fu_241_p4),
    .din1(grp_fu_448_p1),
    .ce(grp_fu_448_ce),
    .dout(grp_fu_448_p2)
);

RGB2yfb_urem_17ns_9ns_17_21_1 #(
    .ID( 1 ),
    .NUM_STAGE( 21 ),
    .din0_WIDTH( 17 ),
    .din1_WIDTH( 9 ),
    .dout_WIDTH( 17 ))
RGB2yfb_urem_17ns_9ns_17_21_1_U3(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .din0(indvar_flatten_next_reg_927),
    .din1(grp_fu_485_p1),
    .ce(grp_fu_485_ce),
    .dout(grp_fu_485_p2)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U4(
    .din0(grp_fu_751_p0),
    .din1(grp_fu_751_p1),
    .din2(tmp_8_reg_949),
    .dout(grp_fu_751_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U5(
    .din0(grp_fu_758_p0),
    .din1(grp_fu_758_p1),
    .din2(tmp1_reg_959),
    .dout(grp_fu_758_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U6(
    .din0(grp_fu_766_p0),
    .din1(grp_fu_766_p1),
    .din2(tmp_8_1_reg_969),
    .dout(grp_fu_766_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U7(
    .din0(grp_fu_773_p0),
    .din1(grp_fu_773_p1),
    .din2(tmp2_reg_979),
    .dout(grp_fu_773_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U8(
    .din0(grp_fu_781_p0),
    .din1(grp_fu_781_p1),
    .din2(tmp_8_2_reg_989),
    .dout(grp_fu_781_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U9(
    .din0(grp_fu_788_p0),
    .din1(grp_fu_788_p1),
    .din2(tmp3_reg_999),
    .dout(grp_fu_788_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U10(
    .din0(grp_fu_796_p0),
    .din1(grp_fu_796_p1),
    .din2(tmp_8_3_reg_1009),
    .dout(grp_fu_796_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U11(
    .din0(grp_fu_803_p0),
    .din1(grp_fu_803_p1),
    .din2(tmp4_reg_1019),
    .dout(grp_fu_803_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U12(
    .din0(grp_fu_811_p0),
    .din1(grp_fu_811_p1),
    .din2(tmp_8_4_reg_1029),
    .dout(grp_fu_811_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U13(
    .din0(grp_fu_818_p0),
    .din1(grp_fu_818_p1),
    .din2(tmp5_reg_1039),
    .dout(grp_fu_818_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U14(
    .din0(grp_fu_826_p0),
    .din1(grp_fu_826_p1),
    .din2(tmp_8_5_reg_1049),
    .dout(grp_fu_826_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U15(
    .din0(grp_fu_833_p0),
    .din1(grp_fu_833_p1),
    .din2(tmp6_reg_1059),
    .dout(grp_fu_833_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U16(
    .din0(grp_fu_841_p0),
    .din1(grp_fu_841_p1),
    .din2(tmp_8_6_reg_1069),
    .dout(grp_fu_841_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U17(
    .din0(grp_fu_848_p0),
    .din1(grp_fu_848_p1),
    .din2(tmp7_reg_1079),
    .dout(grp_fu_848_p3)
);

RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U18(
    .din0(grp_fu_856_p0),
    .din1(grp_fu_856_p1),
    .din2(tmp_8_7_reg_1094),
    .dout(grp_fu_856_p3)
);

RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1 #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U19(
    .din0(grp_fu_863_p0),
    .din1(grp_fu_863_p1),
    .din2(tmp8_reg_1104),
    .dout(grp_fu_863_p3)
);

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter0 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage0_subdone) & (1'b1 == ap_condition_pp0_exit_iter0_state8) & (1'b1 == ap_CS_fsm_pp0_stage0))) begin
            ap_enable_reg_pp0_iter0 <= 1'b0;
        end else if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
            ap_enable_reg_pp0_iter0 <= 1'b1;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter1 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage7_subdone) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
            ap_enable_reg_pp0_iter1 <= ap_enable_reg_pp0_iter0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter2 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage7_subdone) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
            ap_enable_reg_pp0_iter2 <= ap_enable_reg_pp0_iter1;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter3 <= 1'b0;
    end else begin
        if ((((1'b0 == ap_block_pp0_stage7_subdone) & (1'b1 == ap_CS_fsm_pp0_stage7)) | ((1'b0 == ap_block_pp0_stage3_subdone) & (1'b1 == ap_CS_fsm_pp0_stage3)))) begin
            ap_enable_reg_pp0_iter3 <= ap_enable_reg_pp0_iter2;
        end else if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
            ap_enable_reg_pp0_iter3 <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_reg_ioackin_gmem_AWREADY <= 1'b0;
    end else begin
        if ((1'b1 == ap_condition_1293)) begin
            if ((1'b0 == ap_block_pp0_stage5_11001)) begin
                ap_reg_ioackin_gmem_AWREADY <= 1'b0;
            end else if (((1'b0 == ap_block_pp0_stage5_01001) & (gmem_AWREADY == 1'b1))) begin
                ap_reg_ioackin_gmem_AWREADY <= 1'b1;
            end
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_reg_ioackin_gmem_WREADY <= 1'b0;
    end else begin
        if ((1'b1 == ap_condition_1297)) begin
            if ((1'b0 == ap_block_pp0_stage6_11001)) begin
                ap_reg_ioackin_gmem_WREADY <= 1'b0;
            end else if (((1'b0 == ap_block_pp0_stage6_01001) & (gmem_WREADY == 1'b1))) begin
                ap_reg_ioackin_gmem_WREADY <= 1'b1;
            end
        end
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
        blk_idx_reg_282 <= 8'd0;
    end else if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        blk_idx_reg_282 <= blk_idx_1_reg_954;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state36)) begin
        i_reg_226 <= i_1_reg_905;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        i_reg_226 <= 2'd0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
        indvar_flatten_reg_237 <= 17'd0;
    end else if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        indvar_flatten_reg_237 <= indvar_flatten_next_reg_927;
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
        is_first_line_1_reg_269 <= 1'd1;
    end else if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        is_first_line_1_reg_269 <= 1'd0;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state36)) begin
        p_09_rec_reg_214 <= p_1_rec1_fu_746_p2;
    end else if ((1'b1 == ap_CS_fsm_state4)) begin
        p_09_rec_reg_214 <= 40'd0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
        p_1_rec_reg_249 <= 39'd0;
    end else if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        p_1_rec_reg_249 <= tmp_15_mid2_v_v_v_reg_933;
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
        pix_0_1_reg_260 <= video_in_TDATA;
    end else if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        pix_0_1_reg_260 <= tmp_data_V_7_reg_1084;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0))) begin
        blk_7_reg_1123 <= blk_7_fu_718_p9;
        tmp_27_reg_1134 <= tmp_27_fu_740_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_383_p2 == 1'd0))) begin
        blk_idx_1_reg_954 <= blk_idx_1_fu_460_p3;
        tmp_15_mid2_v_v_v_reg_933 <= tmp_15_mid2_v_v_v_fu_406_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0))) begin
        exitcond_flatten_reg_923 <= exitcond_flatten_fu_383_p2;
        exitcond_flatten_reg_923_pp0_iter1_reg <= exitcond_flatten_reg_923;
        exitcond_flatten_reg_923_pp0_iter2_reg <= exitcond_flatten_reg_923_pp0_iter1_reg;
        fb_out2_sum3_reg_1109_pp0_iter2_reg <= fb_out2_sum3_reg_1109;
        y1_6_reg_1099_pp0_iter2_reg <= y1_6_reg_1099;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        fb_out2_sum3_reg_1109 <= fb_out2_sum3_fu_695_p2;
        y1_6_reg_1099 <= {{grp_fu_848_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state5)) begin
        i_1_reg_905 <= i_1_fu_373_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1))) begin
        indvar_flatten_next_reg_927 <= indvar_flatten_next_fu_389_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage3_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage6_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage5_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923 == 1'd0)))) begin
        reg_328 <= {{video_in_TDATA[23:16]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp1_reg_959 <= grp_fu_751_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp2_reg_979 <= grp_fu_766_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp3_reg_999 <= grp_fu_781_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp4_reg_1019 <= grp_fu_796_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp5_reg_1039 <= grp_fu_811_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp6_reg_1059 <= grp_fu_826_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp7_reg_1079 <= grp_fu_841_p3;
        tmp_data_V_7_reg_1084 <= video_in_TDATA;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp8_reg_1104 <= grp_fu_856_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_fu_383_p2 == 1'd0))) begin
        tmp_16_reg_939 <= tmp_16_fu_414_p1;
        tmp_4_reg_944 <= {{ap_phi_mux_pix_0_3_phi_fu_296_p4[23:16]}};
        tmp_8_reg_949 <= tmp_8_fu_442_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_17_reg_964 <= tmp_17_fu_471_p1;
        tmp_8_1_reg_969 <= tmp_8_1_fu_479_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_18_reg_984 <= tmp_18_fu_506_p1;
        tmp_8_2_reg_989 <= tmp_8_2_fu_514_p2;
        y1_reg_974 <= {{grp_fu_758_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_19_reg_1004 <= tmp_19_fu_536_p1;
        tmp_8_3_reg_1009 <= tmp_8_3_fu_544_p2;
        y1_1_reg_994 <= {{grp_fu_773_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state4)) begin
        tmp_1_cast1_reg_892[28 : 0] <= tmp_1_cast1_fu_364_p1[28 : 0];
        tmp_2_reg_897 <= grp_fu_355_p2;
        tmp_3_cast_reg_887[28 : 0] <= tmp_3_cast_fu_361_p1[28 : 0];
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_20_reg_1024 <= tmp_20_fu_566_p1;
        tmp_8_4_reg_1029 <= tmp_8_4_fu_574_p2;
        y1_2_reg_1014 <= {{grp_fu_788_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_21_reg_1044 <= tmp_21_fu_596_p1;
        tmp_8_5_reg_1049 <= tmp_8_5_fu_604_p2;
        y1_3_reg_1034 <= {{grp_fu_803_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_22_reg_1064 <= tmp_22_fu_626_p1;
        tmp_8_6_reg_1069 <= tmp_8_6_fu_634_p2;
        y1_4_reg_1054 <= {{grp_fu_818_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (exitcond_flatten_reg_923 == 1'd0))) begin
        tmp_23_reg_1089 <= tmp_23_fu_656_p1;
        tmp_8_7_reg_1094 <= tmp_8_7_fu_664_p2;
        y1_5_reg_1074 <= {{grp_fu_833_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0))) begin
        tmp_25_reg_1119 <= tmp_25_fu_712_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((ap_start == 1'b1) & (1'b1 == ap_CS_fsm_state1))) begin
        tmp_3_reg_871 <= {{fb_out[31:3]}};
        tmp_reg_876 <= {{stride[31:3]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3))) begin
        y1_1_reg_994_pp0_iter1_reg <= y1_1_reg_994;
        y1_1_reg_994_pp0_iter2_reg <= y1_1_reg_994_pp0_iter1_reg;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4))) begin
        y1_2_reg_1014_pp0_iter1_reg <= y1_2_reg_1014;
        y1_2_reg_1014_pp0_iter2_reg <= y1_2_reg_1014_pp0_iter1_reg;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5))) begin
        y1_3_reg_1034_pp0_iter1_reg <= y1_3_reg_1034;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6))) begin
        y1_4_reg_1054_pp0_iter1_reg <= y1_4_reg_1054;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
        y1_5_reg_1074_pp0_iter1_reg <= y1_5_reg_1074;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_923_pp0_iter1_reg == 1'd0))) begin
        y1_7_reg_1114 <= {{grp_fu_863_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1))) begin
        y1_7_reg_1114_pp0_iter2_reg <= y1_7_reg_1114;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2))) begin
        y1_reg_974_pp0_iter1_reg <= y1_reg_974;
        y1_reg_974_pp0_iter2_reg <= y1_reg_974_pp0_iter1_reg;
    end
end

always @ (*) begin
    if ((exitcond_flatten_fu_383_p2 == 1'd1)) begin
        ap_condition_pp0_exit_iter0_state8 = 1'b1;
    end else begin
        ap_condition_pp0_exit_iter0_state8 = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state5) & (exitcond_fu_367_p2 == 1'd1))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if (((ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b0) & (ap_enable_reg_pp0_iter3 == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b0))) begin
        ap_idle_pp0 = 1'b1;
    end else begin
        ap_idle_pp0 = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        ap_phi_mux_blk_idx_phi_fu_286_p4 = blk_idx_1_reg_954;
    end else begin
        ap_phi_mux_blk_idx_phi_fu_286_p4 = blk_idx_reg_282;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        ap_phi_mux_indvar_flatten_phi_fu_241_p4 = indvar_flatten_next_reg_927;
    end else begin
        ap_phi_mux_indvar_flatten_phi_fu_241_p4 = indvar_flatten_reg_237;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        ap_phi_mux_is_first_line_1_phi_fu_273_p4 = 1'd0;
    end else begin
        ap_phi_mux_is_first_line_1_phi_fu_273_p4 = is_first_line_1_reg_269;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        ap_phi_mux_p_1_rec_phi_fu_253_p4 = tmp_15_mid2_v_v_v_reg_933;
    end else begin
        ap_phi_mux_p_1_rec_phi_fu_253_p4 = p_1_rec_reg_249;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_923 == 1'd0))) begin
        ap_phi_mux_pix_0_1_phi_fu_263_p4 = tmp_data_V_7_reg_1084;
    end else begin
        ap_phi_mux_pix_0_1_phi_fu_263_p4 = pix_0_1_reg_260;
    end
end

always @ (*) begin
    if ((1'b1 == ap_condition_1290)) begin
        if ((ap_phi_mux_is_first_line_1_phi_fu_273_p4 == 1'd0)) begin
            ap_phi_mux_pix_0_3_phi_fu_296_p4 = video_in_TDATA;
        end else if ((ap_phi_mux_is_first_line_1_phi_fu_273_p4 == 1'd1)) begin
            ap_phi_mux_pix_0_3_phi_fu_296_p4 = ap_phi_mux_pix_0_1_phi_fu_263_p4;
        end else begin
            ap_phi_mux_pix_0_3_phi_fu_296_p4 = ap_phi_reg_pp0_iter0_pix_0_3_reg_293;
        end
    end else begin
        ap_phi_mux_pix_0_3_phi_fu_296_p4 = ap_phi_reg_pp0_iter0_pix_0_3_reg_293;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state5) & (exitcond_fu_367_p2 == 1'd1))) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((ap_reg_ioackin_gmem_AWREADY == 1'b0)) begin
        ap_sig_ioackin_gmem_AWREADY = gmem_AWREADY;
    end else begin
        ap_sig_ioackin_gmem_AWREADY = 1'b1;
    end
end

always @ (*) begin
    if ((ap_reg_ioackin_gmem_WREADY == 1'b0)) begin
        ap_sig_ioackin_gmem_WREADY = gmem_WREADY;
    end else begin
        ap_sig_ioackin_gmem_WREADY = 1'b1;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage5_01001) & (ap_reg_ioackin_gmem_AWREADY == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (tmp_25_reg_1119 == 1'd1))) begin
        gmem_AWVALID = 1'b1;
    end else begin
        gmem_AWVALID = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (ap_enable_reg_pp0_iter3 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (tmp_27_reg_1134 == 1'd1))) begin
        gmem_BREADY = 1'b1;
    end else begin
        gmem_BREADY = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage6_01001) & (ap_reg_ioackin_gmem_WREADY == 1'b0) & (1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0))) begin
        gmem_WVALID = 1'b1;
    end else begin
        gmem_WVALID = 1'b0;
    end
end

always @ (*) begin
    if (((ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (tmp_25_reg_1119 == 1'd1) & (1'b0 == ap_block_pp0_stage5))) begin
        gmem_blk_n_AW = m_axi_gmem_AWREADY;
    end else begin
        gmem_blk_n_AW = 1'b1;
    end
end

always @ (*) begin
    if (((ap_enable_reg_pp0_iter3 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (1'b0 == ap_block_pp0_stage3) & (tmp_27_reg_1134 == 1'd1))) begin
        gmem_blk_n_B = m_axi_gmem_BVALID;
    end else begin
        gmem_blk_n_B = 1'b1;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0) & (1'b0 == ap_block_pp0_stage6))) begin
        gmem_blk_n_W = m_axi_gmem_WREADY;
    end else begin
        gmem_blk_n_W = 1'b1;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0)) | ((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2)) | ((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3)) | ((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5)))) begin
        grp_fu_448_ce = 1'b1;
    end else begin
        grp_fu_448_ce = 1'b0;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0)) | ((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2)) | ((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3)) | ((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5)))) begin
        grp_fu_485_ce = 1'b1;
    end else begin
        grp_fu_485_ce = 1'b0;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (ap_phi_mux_is_first_line_1_phi_fu_273_p4 == 1'd0) & (exitcond_flatten_fu_383_p2 == 1'd0)) | ((1'b0 == ap_block_pp0_stage7) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage4) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b0 == ap_block_pp0_stage2) & (exitcond_flatten_reg_923 == 1'd0)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (1'b0 == ap_block_pp0_stage1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_CS_fsm_state7) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (1'b0 == ap_block_pp0_stage3) & (exitcond_flatten_reg_923 == 1'd0)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_923 == 1'd0) & (1'b0 == ap_block_pp0_stage6)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923 == 1'd0) & (1'b0 == ap_block_pp0_stage5)))) begin
        video_in_TDATA_blk_n = video_in_TVALID;
    end else begin
        video_in_TDATA_blk_n = 1'b1;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (ap_predicate_op99_read_state8 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1)) | ((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_923 == 1'd0)) | (~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) | ((1'b0 == ap_block_pp0_stage3_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage6_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b0 == ap_block_pp0_stage5_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_923 == 1'd0)))) begin
        video_in_TREADY = 1'b1;
    end else begin
        video_in_TREADY = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((ap_start == 1'b1) & (1'b1 == ap_CS_fsm_state1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            ap_NS_fsm = ap_ST_fsm_state3;
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            ap_NS_fsm = ap_ST_fsm_state5;
        end
        ap_ST_fsm_state5 : begin
            if (((1'b1 == ap_CS_fsm_state5) & (exitcond_fu_367_p2 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state6;
            end
        end
        ap_ST_fsm_state6 : begin
            ap_NS_fsm = ap_ST_fsm_state7;
        end
        ap_ST_fsm_state7 : begin
            if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd1) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end else if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_user_V_fu_379_p1 == 1'd0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state6;
            end else if ((~((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state7) & (tmp_1_nbreadreq_fu_160_p9 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state7;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state7;
            end
        end
        ap_ST_fsm_pp0_stage0 : begin
            if ((~((1'b0 == ap_block_pp0_stage0_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_383_p2 == 1'd1)) & (1'b0 == ap_block_pp0_stage0_subdone))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage1;
            end else if (((1'b0 == ap_block_pp0_stage0_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_383_p2 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state36;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end
        end
        ap_ST_fsm_pp0_stage1 : begin
            if ((1'b0 == ap_block_pp0_stage1_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage1;
            end
        end
        ap_ST_fsm_pp0_stage2 : begin
            if ((1'b0 == ap_block_pp0_stage2_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage3;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage2;
            end
        end
        ap_ST_fsm_pp0_stage3 : begin
            if ((~((1'b0 == ap_block_pp0_stage3_subdone) & (ap_enable_reg_pp0_iter3 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter2 == 1'b0)) & (1'b0 == ap_block_pp0_stage3_subdone))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage4;
            end else if (((1'b0 == ap_block_pp0_stage3_subdone) & (ap_enable_reg_pp0_iter3 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter2 == 1'b0))) begin
                ap_NS_fsm = ap_ST_fsm_state36;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage3;
            end
        end
        ap_ST_fsm_pp0_stage4 : begin
            if ((1'b0 == ap_block_pp0_stage4_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage4;
            end
        end
        ap_ST_fsm_pp0_stage5 : begin
            if ((1'b0 == ap_block_pp0_stage5_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage6;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage5;
            end
        end
        ap_ST_fsm_pp0_stage6 : begin
            if ((1'b0 == ap_block_pp0_stage6_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage7;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage6;
            end
        end
        ap_ST_fsm_pp0_stage7 : begin
            if ((1'b0 == ap_block_pp0_stage7_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage7;
            end
        end
        ap_ST_fsm_state36 : begin
            ap_NS_fsm = ap_ST_fsm_state5;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign ap_CS_fsm_pp0_stage0 = ap_CS_fsm[32'd7];

assign ap_CS_fsm_pp0_stage1 = ap_CS_fsm[32'd8];

assign ap_CS_fsm_pp0_stage2 = ap_CS_fsm[32'd9];

assign ap_CS_fsm_pp0_stage3 = ap_CS_fsm[32'd10];

assign ap_CS_fsm_pp0_stage4 = ap_CS_fsm[32'd11];

assign ap_CS_fsm_pp0_stage5 = ap_CS_fsm[32'd12];

assign ap_CS_fsm_pp0_stage6 = ap_CS_fsm[32'd13];

assign ap_CS_fsm_pp0_stage7 = ap_CS_fsm[32'd14];

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state36 = ap_CS_fsm[32'd15];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state5 = ap_CS_fsm[32'd4];

assign ap_CS_fsm_state7 = ap_CS_fsm[32'd6];

assign ap_block_pp0_stage0 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage0_11001 = ((ap_predicate_op99_read_state8 == 1'b1) & (video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1));
end

always @ (*) begin
    ap_block_pp0_stage0_subdone = ((ap_predicate_op99_read_state8 == 1'b1) & (video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1));
end

assign ap_block_pp0_stage1 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage1_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage1_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

assign ap_block_pp0_stage2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage2_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage2_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

assign ap_block_pp0_stage3 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage3_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((gmem_BVALID == 1'b0) & (ap_enable_reg_pp0_iter3 == 1'b1) & (tmp_27_reg_1134 == 1'd1)));
end

always @ (*) begin
    ap_block_pp0_stage3_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((gmem_BVALID == 1'b0) & (ap_enable_reg_pp0_iter3 == 1'b1) & (tmp_27_reg_1134 == 1'd1)));
end

assign ap_block_pp0_stage4 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage4_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage4_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

assign ap_block_pp0_stage5 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage5_01001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage5_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_block_state29_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

always @ (*) begin
    ap_block_pp0_stage5_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_block_state29_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

assign ap_block_pp0_stage6 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage6_01001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage6_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_block_state30_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

always @ (*) begin
    ap_block_pp0_stage6_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0)) | ((1'b1 == ap_block_state30_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

assign ap_block_pp0_stage7 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage7_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage7_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state10_pp0_stage2_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state11_pp0_stage3_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state12_pp0_stage4_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state13_pp0_stage5_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state14_pp0_stage6_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_block_state15_pp0_stage7_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

assign ap_block_state16_pp0_stage0_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state17_pp0_stage1_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state18_pp0_stage2_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state19_pp0_stage3_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state20_pp0_stage4_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state21_pp0_stage5_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state22_pp0_stage6_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state23_pp0_stage7_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state24_pp0_stage0_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state25_pp0_stage1_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state26_pp0_stage2_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state27_pp0_stage3_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state28_pp0_stage4_iter2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state29_io = ((ap_sig_ioackin_gmem_AWREADY == 1'b0) & (tmp_25_reg_1119 == 1'd1));
end

assign ap_block_state29_pp0_stage5_iter2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state30_io = ((ap_sig_ioackin_gmem_WREADY == 1'b0) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0));
end

assign ap_block_state30_pp0_stage6_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state31_pp0_stage7_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state32_pp0_stage0_iter3 = ~(1'b1 == 1'b1);

assign ap_block_state33_pp0_stage1_iter3 = ~(1'b1 == 1'b1);

assign ap_block_state34_pp0_stage2_iter3 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state35_pp0_stage3_iter3 = ((gmem_BVALID == 1'b0) & (tmp_27_reg_1134 == 1'd1));
end

always @ (*) begin
    ap_block_state7 = ((video_in_TVALID == 1'b0) & (tmp_1_nbreadreq_fu_160_p9 == 1'd1));
end

always @ (*) begin
    ap_block_state8_pp0_stage0_iter0 = ((ap_predicate_op99_read_state8 == 1'b1) & (video_in_TVALID == 1'b0));
end

always @ (*) begin
    ap_block_state9_pp0_stage1_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_923 == 1'd0));
end

always @ (*) begin
    ap_condition_1290 = ((1'b0 == ap_block_pp0_stage0) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_383_p2 == 1'd0));
end

always @ (*) begin
    ap_condition_1293 = ((ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage5) & (tmp_25_reg_1119 == 1'd1));
end

always @ (*) begin
    ap_condition_1297 = ((1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_923_pp0_iter2_reg == 1'd0));
end

assign ap_enable_pp0 = (ap_idle_pp0 ^ 1'b1);

assign ap_phi_reg_pp0_iter0_pix_0_3_reg_293 = 'bx;

always @ (*) begin
    ap_predicate_op99_read_state8 = ((ap_phi_mux_is_first_line_1_phi_fu_273_p4 == 1'd0) & (exitcond_flatten_fu_383_p2 == 1'd0));
end

always @ (*) begin
    ap_rst_n_inv = ~ap_rst_n;
end

assign blk_7_fu_718_p9 = {{{{{{{{y1_7_reg_1114_pp0_iter2_reg}, {y1_6_reg_1099_pp0_iter2_reg}}, {y1_5_reg_1074_pp0_iter1_reg}}, {y1_4_reg_1054_pp0_iter1_reg}}, {y1_3_reg_1034_pp0_iter1_reg}}, {y1_2_reg_1014_pp0_iter2_reg}}, {y1_1_reg_994_pp0_iter2_reg}}, {y1_reg_974_pp0_iter2_reg}};

assign blk_idx_1_fu_460_p3 = ((tmp_7_fu_395_p2[0:0] === 1'b1) ? 8'd1 : blk_idx_op_fu_454_p2);

assign blk_idx_op_fu_454_p2 = (ap_phi_mux_blk_idx_phi_fu_286_p4 + 8'd1);

assign exitcond_flatten_fu_383_p2 = ((ap_phi_mux_indvar_flatten_phi_fu_241_p4 == 17'd115200) ? 1'b1 : 1'b0);

assign exitcond_fu_367_p2 = ((i_reg_226 == 2'd2) ? 1'b1 : 1'b0);

assign fb_out2_sum3_cast_fu_730_p1 = fb_out2_sum3_reg_1109_pp0_iter2_reg;

assign fb_out2_sum3_fu_695_p2 = (tmp_15_mid2_v_fu_673_p2 + tmp_3_cast_reg_887);

assign gmem_AWADDR = fb_out2_sum3_cast_fu_730_p1;

assign grp_fu_308_p4 = {{video_in_TDATA[15:8]}};

assign grp_fu_355_p0 = grp_fu_355_p00;

assign grp_fu_355_p00 = tmp_reg_876;

assign grp_fu_355_p1 = 40'd720;

assign grp_fu_448_p1 = 17'd160;

assign grp_fu_485_p1 = 17'd160;

assign grp_fu_751_p0 = 16'd77;

assign grp_fu_751_p1 = grp_fu_751_p10;

assign grp_fu_751_p10 = tmp_4_reg_944;

assign grp_fu_758_p0 = 14'd29;

assign grp_fu_758_p1 = grp_fu_758_p10;

assign grp_fu_758_p10 = tmp_16_reg_939;

assign grp_fu_766_p0 = 16'd77;

assign grp_fu_766_p1 = grp_fu_766_p10;

assign grp_fu_766_p10 = reg_328;

assign grp_fu_773_p0 = 14'd29;

assign grp_fu_773_p1 = grp_fu_773_p10;

assign grp_fu_773_p10 = tmp_17_reg_964;

assign grp_fu_781_p0 = 16'd77;

assign grp_fu_781_p1 = grp_fu_781_p10;

assign grp_fu_781_p10 = reg_328;

assign grp_fu_788_p0 = 14'd29;

assign grp_fu_788_p1 = grp_fu_788_p10;

assign grp_fu_788_p10 = tmp_18_reg_984;

assign grp_fu_796_p0 = 16'd77;

assign grp_fu_796_p1 = grp_fu_796_p10;

assign grp_fu_796_p10 = reg_328;

assign grp_fu_803_p0 = 14'd29;

assign grp_fu_803_p1 = grp_fu_803_p10;

assign grp_fu_803_p10 = tmp_19_reg_1004;

assign grp_fu_811_p0 = 16'd77;

assign grp_fu_811_p1 = grp_fu_811_p10;

assign grp_fu_811_p10 = reg_328;

assign grp_fu_818_p0 = 14'd29;

assign grp_fu_818_p1 = grp_fu_818_p10;

assign grp_fu_818_p10 = tmp_20_reg_1024;

assign grp_fu_826_p0 = 16'd77;

assign grp_fu_826_p1 = grp_fu_826_p10;

assign grp_fu_826_p10 = reg_328;

assign grp_fu_833_p0 = 14'd29;

assign grp_fu_833_p1 = grp_fu_833_p10;

assign grp_fu_833_p10 = tmp_21_reg_1044;

assign grp_fu_841_p0 = 16'd77;

assign grp_fu_841_p1 = grp_fu_841_p10;

assign grp_fu_841_p10 = reg_328;

assign grp_fu_848_p0 = 14'd29;

assign grp_fu_848_p1 = grp_fu_848_p10;

assign grp_fu_848_p10 = tmp_22_reg_1064;

assign grp_fu_856_p0 = 16'd77;

assign grp_fu_856_p1 = grp_fu_856_p10;

assign grp_fu_856_p10 = reg_328;

assign grp_fu_863_p0 = 14'd29;

assign grp_fu_863_p1 = grp_fu_863_p10;

assign grp_fu_863_p10 = tmp_23_reg_1089;

assign i_1_fu_373_p2 = (i_reg_226 + 2'd1);

assign indvar_flatten_next_fu_389_p2 = (ap_phi_mux_indvar_flatten_phi_fu_241_p4 + 17'd1);

assign p_1_rec1_fu_746_p2 = (tmp_2_reg_897 + p_09_rec_reg_214);

assign p_rec_dup4_fu_401_p2 = (ap_phi_mux_p_1_rec_phi_fu_253_p4 + tmp_1_cast1_reg_892);

assign tmp_15_mid2_v_fu_673_p2 = (p_09_rec_reg_214 + tmp_15_mid2_v_v_fu_670_p1);

assign tmp_15_mid2_v_v_fu_670_p1 = tmp_15_mid2_v_v_v_reg_933;

assign tmp_15_mid2_v_v_v_fu_406_p3 = ((tmp_7_fu_395_p2[0:0] === 1'b1) ? p_rec_dup4_fu_401_p2 : ap_phi_mux_p_1_rec_phi_fu_253_p4);

assign tmp_16_fu_414_p1 = ap_phi_mux_pix_0_3_phi_fu_296_p4[7:0];

assign tmp_17_fu_471_p1 = video_in_TDATA[7:0];

assign tmp_18_fu_506_p1 = video_in_TDATA[7:0];

assign tmp_19_fu_536_p1 = video_in_TDATA[7:0];

assign tmp_1_cast1_fu_364_p1 = tmp_reg_876;

assign tmp_1_nbreadreq_fu_160_p9 = video_in_TVALID;

assign tmp_20_fu_566_p1 = video_in_TDATA[7:0];

assign tmp_21_fu_596_p1 = video_in_TDATA[7:0];

assign tmp_22_fu_626_p1 = video_in_TDATA[7:0];

assign tmp_23_fu_656_p1 = video_in_TDATA[7:0];

assign tmp_25_fu_712_p2 = ((grp_fu_448_p2 == 17'd0) ? 1'b1 : 1'b0);

assign tmp_27_fu_740_p2 = ((grp_fu_485_p2 == 17'd0) ? 1'b1 : 1'b0);

assign tmp_3_cast_fu_361_p1 = tmp_3_reg_871;

assign tmp_7_fu_395_p2 = ((ap_phi_mux_blk_idx_phi_fu_286_p4 == 8'd160) ? 1'b1 : 1'b0);

assign tmp_8_1_fu_479_p1 = tmp_8_1_fu_479_p10;

assign tmp_8_1_fu_479_p10 = grp_fu_308_p4;

assign tmp_8_1_fu_479_p2 = (16'd150 * tmp_8_1_fu_479_p1);

assign tmp_8_2_fu_514_p1 = tmp_8_2_fu_514_p10;

assign tmp_8_2_fu_514_p10 = grp_fu_308_p4;

assign tmp_8_2_fu_514_p2 = (16'd150 * tmp_8_2_fu_514_p1);

assign tmp_8_3_fu_544_p1 = tmp_8_3_fu_544_p10;

assign tmp_8_3_fu_544_p10 = grp_fu_308_p4;

assign tmp_8_3_fu_544_p2 = (16'd150 * tmp_8_3_fu_544_p1);

assign tmp_8_4_fu_574_p1 = tmp_8_4_fu_574_p10;

assign tmp_8_4_fu_574_p10 = grp_fu_308_p4;

assign tmp_8_4_fu_574_p2 = (16'd150 * tmp_8_4_fu_574_p1);

assign tmp_8_5_fu_604_p1 = tmp_8_5_fu_604_p10;

assign tmp_8_5_fu_604_p10 = grp_fu_308_p4;

assign tmp_8_5_fu_604_p2 = (16'd150 * tmp_8_5_fu_604_p1);

assign tmp_8_6_fu_634_p1 = tmp_8_6_fu_634_p10;

assign tmp_8_6_fu_634_p10 = grp_fu_308_p4;

assign tmp_8_6_fu_634_p2 = (16'd150 * tmp_8_6_fu_634_p1);

assign tmp_8_7_fu_664_p1 = tmp_8_7_fu_664_p10;

assign tmp_8_7_fu_664_p10 = grp_fu_308_p4;

assign tmp_8_7_fu_664_p2 = (16'd150 * tmp_8_7_fu_664_p1);

assign tmp_8_fu_442_p1 = tmp_8_fu_442_p10;

assign tmp_8_fu_442_p10 = tmp_9_cast_fu_418_p4;

assign tmp_8_fu_442_p2 = (16'd150 * tmp_8_fu_442_p1);

assign tmp_9_cast_fu_418_p4 = {{ap_phi_mux_pix_0_3_phi_fu_296_p4[15:8]}};

assign tmp_user_V_fu_379_p1 = video_in_TUSER;

always @ (posedge ap_clk) begin
    tmp_3_cast_reg_887[39:29] <= 11'b00000000000;
    tmp_1_cast1_reg_892[38:29] <= 10'b0000000000;
end

endmodule //RGB2yfb
